module Kitsu
  class Producer

    attr_accessor :data

    def initialize(data)
      @data = data
    end



    def anime(**filters)
      anime = anime_related.map do |parsed|
        Kitsu::Anime.new(parsed)
      end
      anime.select do |a|
        filters.all? do |key, value|
          a.data['attributes'][key.to_s] == value

        end
      end
    end



    def anime_related
      library_entries.map(&:related_anime).flatten
    end




    def library_entries
      parsed = API.get(@data['relationships']['animeProductions']['links']['related'])

      library_entries = [parsed]
      loop do
        parsed = API.get(parsed['links']['next'])
        library_entries << parsed
        break unless parsed['links'].key? 'next'
      end

      library_entries.flatten.map do |producer|
        Kitsu::LibraryEntry.new(producer)
      end
    end


    def self.find(studio)
      parsed = API.get("producers?filter[slug]=#{studio}")
      self.new(parsed['data'].first)
    end
  end
end
