module Kitsu
  class User
    attr_accessor :data

    def initialize(data)
      @data = data
    end

    def anime(**filters)
      anime = anime_related.map do |parsed|
        Kitsu::Anime.new(parsed)
      end

      anime.select do |a|
        filters.all? do |key, value|
          a.data['attributes'][key.to_s] == value
        end
      end
    end

    def anime_related
      library_entries.map(&:related_anime).flatten
    end

    def library_entries
      parsed = API.get(@data['relationships']['libraryEntries']['links']['related'])

      library_entries = [parsed]
      loop do
        parsed = API.get(parsed['links']['next'])
        library_entries << parsed
        break unless parsed['links'].key? 'next'
      end
      library_entries.flatten.map do |parsed|
        Kitsu::LibraryEntry.new(parsed)
      end
    end

    def self.find(username)
      parsed = API.get("users?filter[name]=#{username}")
      self.new(parsed['data'].first)
    end
  end
end
